clear; set(0,'defaultaxesfontsize',20); format long
%%% p4.m MCMC INDEPENDENCE DYNAMICS SAMPLER algorithm 
%%% for sin map (Ex. 1.3) with noise
%% setup

J=10;% number of steps
alpha=2.5;% dynamics determined by alpha
gamma=1;% observational noise variance is gamma^2
sigma=1;% dynamics noise variance is sigma^2
C0=1;% prior initial condition variance
m0=0;% prior initial condition mean
sd=0;rng(sd);% choose random number seed
 
%% truth

vt(1)=m0+sqrt(C0)*randn;% truth initial condition 
Phi=0; 

for j=1:J
    vt(j+1)=alpha*sin(vt(j))+sigma*randn;% create truth
    y(j)=vt(j+1)+gamma*randn;% create data
    % calculate log likelihood of truth, Phi(v;y) from (1.11)
    Phi=Phi+1/2/gamma^2*(y(j)-vt(j+1))^2;
end

%% solution
% Markov Chain Monte Carlo: N forward steps of the
% Markov Chain on R^{J+1} with truth initial condition
N=1e5;% number of samples
V=zeros(N,J+1);% preallocate space to save time
v=vt;% truth initial condition (or else update Phi) 
n=1; bb=0; rat(1)=0; 
while n<=N
    w(1)=sqrt(C0)*randn;% propose sample from the  prior 
    Phiprop=0; 
    for j=1:J
    w(j+1)=alpha*sin(w(j))+sigma*randn;% propose sample from the prior 
    Phiprop=Phiprop+1/2/gamma^2*(y(j)-w(j+1))^2;% compute likelihood
    end
    if rand<exp(Phi-Phiprop)% accept or reject proposed sample
       v=w; Phi=Phiprop; bb=bb+1;% update the Markov chain
    end
   rat(n)=bb/n;% running rate of acceptance
   V(n,:)=v;% store the chain
   n=n+1;
end
% plot acceptance ratio and cumulative sample mean
figure;plot(rat)
figure;plot(cumsum(V(1:N,1))./[1:N]')
xlabel('samples N')
ylabel('(1/N) \Sigma_{n=1}^N v_0^{(n)}')








